diff -uNr ntop-3.3.8/util.c ntop-3.3.9/util.c
--- ntop-3.3.8/util.c	2008-10-01 23:03:36.000000000 +0200
+++ ntop-3.3.9/util.c	2008-12-09 19:37:20.000000000 +0100
@@ -24,7 +24,10 @@
 
 #include "ntop.h"
 #include <stdarg.h>
+
+#ifndef WIN32
 #include <syslog.h>
+#endif
 
 /* #define ADDRESS_DEBUG */
 /* #define FINGERPRINT_DEBUG */
@@ -207,13 +210,13 @@
 
     for(i=0, j=0; j<sizeof(HostSerial); j++) {
 	  u_int c;
-	  
+
       tmpStr[0] = buf[i++];
       tmpStr[1] = buf[i++];
       tmpStr[2] = '\0';
       sscanf(tmpStr, "%02X", &c);
 	  ptr[j] = c & 0xFF;
-	  
+
 	  /*
 	   ptr[j] = ((u_int8_t)buf[i]) * 16 + ((u_int8_t)buf[i+1]);
 	   i += 2;
@@ -398,10 +401,12 @@
   dst->hostFamily = src->hostFamily;
   switch (src->hostFamily) {
   case AF_INET:
-    return memcpy(&dst->Ip4Address,&src->Ip4Address,sizeof(struct in_addr));
+    memcpy(&dst->Ip4Address,&src->Ip4Address,sizeof(struct in_addr));
+    return(dst);
 #ifdef INET6
   case AF_INET6:
-    return memcpy(&dst->Ip6Address,&src->Ip6Address,sizeof(struct in6_addr));
+    memcpy(&dst->Ip6Address,&src->Ip6Address,sizeof(struct in6_addr));
+    return(dst);
 #endif
 
   default:
@@ -768,11 +773,11 @@
   u_int8_t i, j, bits = 0, fields[4];
 
   memcpy(fields, &addr, 4);
-  
+
   for(i = 8; i <= 8; i--)
     for(j=0; j<4; j++)
-      if ((fields[j] & (1 << i)) != 0) bits++;	
-  
+      if ((fields[j] & (1 << i)) != 0) bits++;
+
     return(bits);
 }
 
@@ -933,7 +938,7 @@
 
 int dotted2bits(char *mask) {
   int fields[4], fields_num;
-  
+
   fields_num = sscanf(mask, "%d.%d.%d.%d",
 		      &fields[0], &fields[1], &fields[2], &fields[3]);
 
@@ -943,9 +948,9 @@
 #endif
     return(atoi(mask));
   } else
-    return(num_network_bits(((fields[0] & 0xff) << 24) 
+    return(num_network_bits(((fields[0] & 0xff) << 24)
 			    + ((fields[1] & 0xff) << 16)
-			    + ((fields[2] & 0xff) << 8) 
+			    + ((fields[2] & 0xff) << 8)
 			    + (fields[3] & 0xff)));
 }
 
@@ -980,14 +985,14 @@
     int bits, a, b, c, d;
     char *mask = strchr(address, '/');
     char *equal = strchr(address, '=');
-    
+
     if(equal != NULL) {
       char key[64];
       equal[0] = '\0';
       safe_snprintf(__FILE__, __LINE__, key, sizeof(key), "subnet.name.%s", address);
       storePrefsValue(key, &equal[1]);
     }
-      
+
     if(mask == NULL) {
       bits = 32;
     } else {
@@ -1144,15 +1149,15 @@
 
 void handleLocalAddresses(char* addresses) {
   char localAddresses[2048];
-  
+
   localAddresses[0] = '\0';
 
   if(addresses != NULL) {
     char *addresses_copy = strdup(addresses);
-    
+
     handleAddressLists(addresses_copy, myGlobals.localNetworks, &myGlobals.numLocalNetworks,
 		       localAddresses, sizeof(localAddresses), CONST_HANDLEADDRESSLISTS_MAIN);
-    
+
     free(addresses_copy);
   }
 
@@ -1174,14 +1179,14 @@
   } else {
     char line[256];
     int idx = 0;
-    
+
     while(!feof(fd) && (fgets(line, sizeof(line), fd) != NULL)) {
       if((line[0] == '#') || (line[0] == '\n')) continue;
       while(strlen(line) && (line[strlen(line)-1] == '\n')) {
 	line[strlen(line)-1] = '\0';
       }
-      
-      safe_snprintf(__FILE__, __LINE__, &buf[idx], buf_len-idx-2, "%s%s", (idx > 0) ? "," : "", line);     
+
+      safe_snprintf(__FILE__, __LINE__, &buf[idx], buf_len-idx-2, "%s%s", (idx > 0) ? "," : "", line);
       idx = strlen(buf);
     }
 
@@ -1208,11 +1213,11 @@
 	addresses_copy = strdup(buf);
     } else
       addresses_copy = strdup(addresses);
-    
+
     if(addresses_copy) {
       handleAddressLists(addresses_copy, myGlobals.subnetStats, &myGlobals.numKnownSubnets,
 			 knownSubnets, sizeof(knownSubnets), CONST_HANDLEADDRESSLISTS_MAIN);
-      
+
       free(addresses_copy);
     }
   }
@@ -2067,7 +2072,7 @@
   if(!mutexId->isLocked) {
     traceEvent(CONST_TRACE_WARNING, "releaseMutex() called with an UN-LOCKED mutex [t%lu m%p @%s:%d] last unlock [t%lu m%u @%s:%d]",
 	       pthread_self(), (void*)&(mutexId->mutex), fileName, fileLine,
-               mutexId->unlock.thread, (int)mutexId->unlock.pid, 
+               mutexId->unlock.thread, (int)mutexId->unlock.pid,
 	       mutexId->unlock.file, mutexId->unlock.line);
 
   }
@@ -2482,8 +2487,6 @@
   el->dnsDomainValue = NULL;
   if (el->dnsTLDValue != NULL)         free(el->dnsTLDValue);
   el->dnsTLDValue = NULL;
-  if (el->ip2ccValue != NULL)          free(el->ip2ccValue);
-  el->ip2ccValue = NULL;
   el->hostResolvedName[0] = '\0';
   el->hostResolvedNameType = FLAG_HOST_SYM_ADDR_TYPE_NONE;
   if (el->fingerprint != NULL)         free(el->fingerprint);
@@ -2493,6 +2496,8 @@
   if (el->routedTraffic != NULL)       free(el->routedTraffic);
   el->routedTraffic = NULL;
   if (el->portsUsage != NULL)          freePortsUsage(el);
+  if (el->geo_ip)                      GeoIPRecord_delete(el->geo_ip);
+
   if (el->protoIPTrafficInfos != NULL) {
     int i;
 
@@ -3174,7 +3179,7 @@
 	revertSlashIfWIN32(string, 0);
 #endif
 
-  
+
   for(i=k, j=1; i<strlen(string)-k; i++) {
     int idx = string[i];
 
@@ -3461,8 +3466,6 @@
   el->dnsDomainValue = NULL;
   if(el->dnsTLDValue != NULL) free(el->dnsTLDValue);
   el->dnsTLDValue = NULL;
-  if(el->ip2ccValue != NULL) free(el->ip2ccValue);
-  el->ip2ccValue = NULL;
 
   if((el->hostResolvedNameType != FLAG_HOST_SYM_ADDR_TYPE_NAME) ||
      (el->hostResolvedName    == NULL) ||
@@ -3472,15 +3475,6 @@
     return;
   }
 
-  ip2cc = ip2CountryCode(el->hostIpAddress);
-
-  if((ip2cc == NULL) || (strcmp(ip2cc, "***") == 0)) {
-    /* We are unable to associate a domain with this IP address. */
-    el->ip2ccValue = NULL;
-  } else {
-    el->ip2ccValue = strdup(ip2cc);
-  }
-
   /* Walk back to the last . */
   i = strlen(el->hostResolvedName)-1;
   while(i > 0)
@@ -3494,7 +3488,7 @@
    */
   if(i > 0)
     el->dnsTLDValue = strdup(&el->hostResolvedName[i+1]);
-  else if((myGlobals.shortDomainName != NULL) 
+  else if((myGlobals.shortDomainName != NULL)
 	  && (myGlobals.shortDomainName[0] != '\0')) {
     /* Walk back to the last . */
     i = strlen(myGlobals.shortDomainName)-1;
@@ -3593,7 +3587,7 @@
 	  int i;
 
 	  for(i=0; i<strlen(nbName); i++) {
-	    if(isupper(nbName[i])) 
+	    if(isupper(nbName[i]))
 	      nbName[i] = tolower(nbName[i]);
 	  }
 
@@ -3811,7 +3805,7 @@
 /* ******************************* */
 
 char* getPortByNum(int port, int type) {
-  char* rsp;
+  char* rsp = NULL;
 
   if(type == IPPROTO_TCP) {
     rsp = getPortByNumber(myGlobals.tcpSvc, port);
@@ -3825,7 +3819,7 @@
 /* ******************************* */
 
 char* getAllPortByNum(int port, char *outBuf, int outBufLen) {
-  char* rsp;
+  char* rsp = NULL;
 
   rsp = getPortByNumber(myGlobals.tcpSvc, port); /* Try TCP first... */
   if(rsp == NULL)
@@ -3842,7 +3836,7 @@
 /* ******************************* */
 
 int getAllPortByName(char* portName) {
-  int rsp;
+  int rsp = 0;
 
   rsp = getPortByName(myGlobals.tcpSvc, portName); /* Try TCP first... */
   if(rsp == -1)
@@ -4155,8 +4149,8 @@
         memset(&remAmount, 0, sizeof(remAmount));
 
         traceEvent(CONST_BEYONDNOISY_TRACE_LEVEL, file, line,
-		   "nanosleep({%d, %d}, )", 
-		   (int)sleepAmount.tv_sec, 
+		   "nanosleep({%d, %d}, )",
+		   (int)sleepAmount.tv_sec,
 		   (int)sleepAmount.tv_nsec);
 
         if((nanosleep(&sleepAmount, &remAmount) != 0) && (errno == EINTR)) {
@@ -4310,7 +4304,7 @@
 
   for(el=getFirstHost(deviceId);
       el != NULL; el = getNextHost(deviceId, el)) {
-    if(broadcastHost(el) 
+    if(broadcastHost(el)
        || ((myGlobals.actTime-el->lastSeen) > PARM_HOST_PURGE_MINIMUM_IDLE_NOACTVSES))
       continue;
     else if (isFcHost (el) && (el->fcCounters->hostFcAddress.domain == FC_ID_SYSTEM_DOMAIN))
@@ -4357,71 +4351,6 @@
   return((a&0xFF)<<24)|((b&0xFF)<<16)|((c&0xFF)<<8)|(d&0xFF);
 }
 
-/* ******************************************************************* */
-
-void* addNodeInternal(u_int32_t ip, int prefix, char *country, int as) {
-  IPNode *p1 = NULL, *p2 = NULL;
-  int i, b;
-
-  if(country)
-    p1 = myGlobals.countryFlagHead;
-  else
-    p1 = myGlobals.asHead;
-
-  for(i=0; i<prefix; i++) {
-    b=(ip>>(31-i)) & 0x1;
-    if(!p1->b[b]) {
-      if(!(p2=malloc(sizeof(IPNode))))
-        return(NULL);
-
-      memset(p2, 0, sizeof(IPNode));
-
-      if(country != NULL)
-	myGlobals.ipCountryMem += sizeof(IPNode);
-      else
-	myGlobals.asMem += sizeof(IPNode);
-      p1->b[b]=p2;
-    }
-    else
-      p2=p1->b[b];
-
-    p1=p2;
-  }
-
-  if(country != NULL) {
-    if(p2->node.cc[0] == 0)
-      strncpy(p2->node.cc, country, sizeof(p2->node.cc));
-  } else {
-    if(p2->node.as == 0)
-      p2->node.as = as;
-  }
-
-  return(p2);
-
-}
-
-/* ******************************************************************* */
-
-char *ip2CountryCode(HostAddr ip) {
-  IPNode *p = myGlobals.countryFlagHead;
-  int i, b;
-  char *cc = "";
-  u_int32_t addr;
-
-  if (ip.hostFamily == AF_INET6)
-    return NULL;
-  addr  = ip.Ip4Address.s_addr;
-  i = 0;
-  while(p != NULL) {
-    if(p->node.cc[0] != 0)
-      cc = p->node.cc;
-    b = (addr >>(31-i)) & 0x1;
-    p = p->b[b];
-    i++;
-  }
-
-  return(cc);
-}
 
 /* *************************************** */
 
@@ -4646,7 +4575,7 @@
     setRunState(FLAG_NTOPSTATE_INITNONROOT);
 
   traceEvent(CONST_TRACE_ALWAYSDISPLAY, "Now running as requested user '%s' (%d:%d)",
-             myGlobals.effectiveUserName ? myGlobals.effectiveUserName : "<unknown>", 
+             myGlobals.effectiveUserName ? myGlobals.effectiveUserName : "<unknown>",
 	     myGlobals.userId, myGlobals.groupId);
 
   if((myGlobals.userId != 0) || (myGlobals.groupId != 0)) {
@@ -4679,38 +4608,9 @@
 #endif
 }
 
-/* ******************************************************************* */
-
-u_short ip2AS(HostAddr ip) {
-  IPNode *p;
-  int i, b;
-  u_short as=0;
-  u_int32_t addr;
-
-  if (ip.hostFamily == AF_INET6)
-    return 0;
-
-  addr = ip.Ip4Address.s_addr;
-
-  p = myGlobals.asHead;
-
-  i=0;
-  while(p!=NULL) {
-    if(p->node.as !=0 )
-      as = p->node.as;
-    b=(addr>>(31-i)) & 0x1;
-    p=p->b[b];
-    i++;
-  }
-
-  return(as);
-}
-
 /* ************************************ */
 
 u_int16_t getHostAS(HostTraffic *el) {
-  if (!el->hostAS)
-    el->hostAS = ip2AS(el->hostIpAddress);
   return (el->hostAS);
 }
 
@@ -4729,7 +4629,8 @@
 /* ********************************** */
 
 int copySerial(HostSerial *a, HostSerial *b) {
-  return(!memcpy(a, b, sizeof(HostSerial)));
+  memcpy(a, b, sizeof(HostSerial));
+  return(!a);
 }
 
 /* ********************************** */
@@ -5928,11 +5829,46 @@
 
 }
 
+/* ************************************ */
+
+static void updateGeoIP(HostTraffic *el) {
+  if(el->hostNumIpAddress[0] != '\0') {
+    if((el->geo_ip == NULL) && (myGlobals.geo_ip_db != NULL)) {
+      el->geo_ip = GeoIP_record_by_addr(myGlobals.geo_ip_db, el->hostNumIpAddress);
+
+      if((el->hostAS == 0) && (myGlobals.geo_ip_asn_db != NULL)) {
+	char *rsp = NULL;
+
+	if(el->hostIpAddress.hostFamily == AF_INET)
+	  rsp = GeoIP_name_by_ipnum(myGlobals.geo_ip_asn_db, el->hostIpAddress.Ip4Address.s_addr);
+	else {
+#ifdef INET6
+#ifndef WIN32
+	  rsp = GeoIP_name_by_ipnum_v6(myGlobals.geo_ip_asn_db, el->hostIpAddress.Ip6Address);
+#endif
+#endif
+	}
+
+	if(rsp != NULL) {
+	  /* Example: AS20959 This AS Number will be used by the Datacom Network. */
+	  char *name;
+
+	  name = strchr(rsp, ' ');
+	  el->hostAS = atoi(&rsp[2]);
+	  if(name) el->hostASDescr = strdup(&name[1]);
+	}
+      }
+    }
+  }
+}
+
 /* ********************************************* */
 
 void _setResolvedName(HostTraffic *el, char *updateValue, short updateType, char* file, int line) {
   int i;
 
+  updateGeoIP(el);
+
   if(updateValue[0] == '\0') return;
 
   /* Do not update 0 -> DNS */
@@ -5956,14 +5892,17 @@
 #endif
 
     if (updateType == FLAG_HOST_SYM_ADDR_TYPE_FC_WWN) {
-      safe_snprintf(__FILE__, __LINE__, el->hostResolvedName, sizeof(el->hostResolvedName),
+      safe_snprintf(__FILE__, __LINE__, el->hostResolvedName,
+		    sizeof(el->hostResolvedName),
 		    fcwwn_to_str ((u_int8_t*)updateValue));
       el->hostResolvedName[LEN_WWN_ADDRESS_DISPLAY] = '\0';
+    } else {
+      safe_snprintf(__FILE__, __LINE__, el->hostResolvedName, 
+		    sizeof(el->hostResolvedName), "%s", updateValue);
     }
-    else {
-      strncpy(el->hostResolvedName, updateValue, MAX_LEN_SYM_HOST_NAME-1);
-    }
+
     // el->hostResolvedName[MAX_LEN_SYM_HOST_NAME-1] = '\0';
+    /* Really needed ? */
     for(i=0; el->hostResolvedName[i] != '\0'; i++)
       el->hostResolvedName[i] = tolower(el->hostResolvedName[i]);
 
@@ -6281,69 +6220,6 @@
 
   return(rc);
 }
-
-/* ********************************************* */
-/* ********************************************* */
-/*       Location code compare function          */
-/* ********************************************* */
-
-int cmpFctnLocationName(const void *_a, const void *_b) {
-  /* This function takes two HostTraffic entries and performs a
-     standardized compare of the location, either the ip2ccValue field
-     or the fallback dnsTLDValue fields, handling unvalued
-     situations to provide a stable comparison.
-
-     We translate 'loc' (rfc1918 addresses) to sort next to last
-     and unvalued items to sort last.
-
-     Equal valued names are sorted based first on full domain name, then
-     on hostResolvedName as the tie breakers.
-  */
-
-  HostTraffic **a = (HostTraffic **)_a;
-  HostTraffic **b = (HostTraffic **)_b;
-  int rc;
-  char *nameA, *nameB;
-
-  rc=0;
-
-  if((*a)->ip2ccValue == NULL) {
-    nameA = "\xFF\xFF";
-  } else if(strcasecmp((*a)->ip2ccValue, "loc") == 0) {
-    nameA = "\xFF\xFE";
-  } else {
-    nameA = (*a)->ip2ccValue;
-  }
-  if((*b)->ip2ccValue == NULL) {
-    nameB = "\xFF\xFF";
-  } else if(strcasecmp((*b)->ip2ccValue, "loc") == 0) {
-    nameB = "\xFF\xFE";
-  } else {
-    nameB = (*b)->ip2ccValue;
-  }
-
-  rc = strcasecmp(nameA, nameB);
-  if(rc == 0) {
-    if((*a)->dnsTLDValue == NULL) {
-      nameA = "\xFF\xFF";
-    } else {
-      nameA = (*a)->dnsTLDValue;
-    }
-    if((*b)->dnsTLDValue == NULL) {
-      nameB = "\xFF\xFF";
-    } else {
-      nameB = (*b)->ip2ccValue;
-    }
-    rc = strcasecmp(nameA != NULL ? nameA : "", nameB != NULL ? nameB : "");
-  }
-
-  if(rc == 0) {
-    rc = cmpFctnResolvedName(a, b);
-  }
-
-  return(rc);
-}
-
 /* ************************************ */
 
 static char x2c(char *what) {
@@ -6465,15 +6341,26 @@
  *    into chain, thus keeping the list sorted.
  */
 PortUsage* getPortsUsage(HostTraffic *el, u_int portIdx, int createIfNecessary) {
-  PortUsage *ports = el->portsUsage, *prev = NULL, *newPort;
+  PortUsage *ports, *prev = NULL, *newPort;
+
+  accessMutex(&myGlobals.portsMutex, "getPortsUsage");
+
+  ports = el->portsUsage;
 
   while((ports != NULL) && (ports->port < portIdx)) {
     prev = ports;
     ports = ports->next;
   }
 
-  if(ports && (ports->port == portIdx)) return(ports); /* Found */
-  if(!createIfNecessary) return(NULL);
+  if(ports && (ports->port == portIdx)) {
+    releaseMutex(&myGlobals.portsMutex);
+    return(ports); /* Found */
+  }
+  
+  if(!createIfNecessary) {
+    releaseMutex(&myGlobals.portsMutex);
+    return(NULL);
+  }
 
   newPort = allocatePortUsage();
   newPort->port = portIdx;
@@ -6491,6 +6378,7 @@
     prev->next = newPort;
   }
 
+  releaseMutex(&myGlobals.portsMutex);
   return(newPort);
 }
 
diff -uNr ntop-3.3.8/webInterface.c ntop-3.3.9/webInterface.c
--- ntop-3.3.8/webInterface.c	2008-10-02 12:54:15.000000000 +0200
+++ ntop-3.3.9/webInterface.c	2008-11-07 12:04:30.000000000 +0100
@@ -678,75 +678,65 @@
 /* ************************ */
 
 char* getHostCountryIconURL(HostTraffic *el) {
-  char path[256], *img, *source;
+  char path[256], *img = NULL;
   static char flagBuf[384];
   struct stat buf;
   int rc;
 
   fillDomainName(el);
 
-  if((el->ip2ccValue != NULL) && (strcasecmp(el->ip2ccValue, "loc") == 0)) {
+  if(el->geo_ip == NULL) {
+#if 0
+    safe_snprintf(__FILE__, __LINE__, flagBuf, sizeof(flagBuf),
+		  "<img class=tooltip alt=\"Local Host\" title=\"Local Host\" "
+		  "align=\"middle\" src=\"/statsicons/flags/local.gif\" border=\"0\">");
+#endif
+    return("&nbsp;");
+  }
+
+  if(el->geo_ip->country_code[0] == '\0') {
     safe_snprintf(__FILE__, __LINE__, flagBuf, sizeof(flagBuf),
 		  "<img class=tooltip alt=\"Local Host\" title=\"Local Host\" "
 		  "align=\"middle\" src=\"/statsicons/flags/local.gif\" border=\"0\">");
   } else {
-    /* Try all the possible combos of name and path */
-    rc = -1; /* Start bad */
+    char c_buf[16] = { '\0'};
+    int i;
 
-    if(el->ip2ccValue != NULL) {
-      if(rc != 0) {
-	safe_snprintf(__FILE__, __LINE__, path, sizeof(path), "./html/statsicons/flags/%s.gif",
-		      el->ip2ccValue);
-	rc = stat(path, &buf);
-      }
-      if(rc != 0) {
-	safe_snprintf(__FILE__, __LINE__, path, sizeof(path), "%s/html/statsicons/flags/%s.gif",
-		      CFG_DATAFILE_DIR, el->ip2ccValue);
-	rc = stat(path, &buf);
-      }
-      if(rc == 0) {
-	img = el->ip2ccValue;
-	source = "(from p2c file)";
-      }
-    }
+    safe_snprintf(__FILE__, __LINE__, c_buf, sizeof(c_buf)-1, "%s", el->geo_ip->country_code);
 
-    if(rc != 0) {
-      if(el->dnsTLDValue != NULL) {
-	safe_snprintf(__FILE__, __LINE__, path, sizeof(path), "./html/statsicons/flags/%s.gif",
-		      el->dnsTLDValue);
-	rc = stat(path, &buf);
-
-	if(rc != 0) {
-	  safe_snprintf(__FILE__, __LINE__, path, sizeof(path), "%s/html/statsicons/flags/%s.gif",
-			CFG_DATAFILE_DIR, el->dnsTLDValue);
-	  rc = stat(path, &buf);
-	}
-	if(rc == 0) {
-	  img = el->dnsTLDValue;
-	  if(strlen(img) == 2)
-	    source = "(Guessing from ccTLD)";
-	  else
-	    source = "(Guessing from gTLD)";
-	}
-      }
-    }
+    for(i=0; c_buf[i] != '\0'; i++) c_buf[i] = tolower(c_buf[i]);
 
+    safe_snprintf(__FILE__, __LINE__, path, sizeof(path), "./html/statsicons/flags/%s.gif",
+		  c_buf);
+	revertSlashIfWIN32(path, 0);
+    rc = stat(path, &buf);
+    
     if(rc != 0) {
-      /* Nothing worked... */
-      safe_snprintf(__FILE__, __LINE__, flagBuf, sizeof(flagBuf),
-		    "&nbsp;<!-- No flag for %s or %s -->",
-		    el->ip2ccValue != NULL  ? el->ip2ccValue  : "null",
-		    el->dnsTLDValue != NULL ? el->dnsTLDValue : "null");
-    } else {
-      safe_snprintf(__FILE__, __LINE__, flagBuf, sizeof(flagBuf),
-		    "<img class=tooltip alt=\"Flag for %s code %s %s\" title=\"Flag for %s code %s %s\" align=\"middle\" "
-		    "src=\"/statsicons/flags/%s.gif\" border=\"0\">",
-		    strlen(img) == 2 ? "ISO 3166" : "gTLD", img, source,
-		    strlen(img) == 2 ? "ISO 3166" : "gTLD", img, source,
-		    img);
+      safe_snprintf(__FILE__, __LINE__, path, sizeof(path), "%s/html/statsicons/flags/%s.gif",
+		    CFG_DATAFILE_DIR, el->geo_ip->country_code);
+	  revertSlashIfWIN32(path, 0);
+      rc = stat(path, &buf);
+    } 
+
+    if(rc == 0) {
+      img = c_buf;
     }
   }
 
+  if(img == NULL) {
+    /* Nothing worked... */
+    safe_snprintf(__FILE__, __LINE__, flagBuf, sizeof(flagBuf),
+		  "&nbsp;<!-- No flag for %s (%s) -->",
+		  el->geo_ip->country_name, el->geo_ip->country_code);
+  } else {
+    safe_snprintf(__FILE__, __LINE__, flagBuf, sizeof(flagBuf),
+		  "<img class=tooltip alt=\"Flag for %s (%s)\" title=\"Flag for %s (%s)\" align=\"middle\" "
+		  "src=\"/statsicons/flags/%s.gif\" border=\"0\">",
+		  el->geo_ip->country_name, el->geo_ip->country_code,
+		  el->geo_ip->country_name, el->geo_ip->country_code,
+		  img);
+  }  
+
   return(flagBuf);
 }
 
@@ -6152,6 +6142,14 @@
   snprintf(buf, sizeof(buf), "%1.4f", rrd_version());
   printFeatureConfigInfo(textPrintFlag, "<A HREF=http://www.rrdtool.org/>RRD</A> Version", buf);
 
+  if(myGlobals.geo_ip_db != NULL)
+    printFeatureConfigInfo(textPrintFlag, "<A HREF=http://www.maxmind.com/>GeoIP</A> Version", 
+			   GeoIP_database_info(myGlobals.geo_ip_db));
+
+  if(myGlobals.geo_ip_asn_db != NULL)
+    printFeatureConfigInfo(textPrintFlag, "<A HREF=http://www.maxmind.com/>GeoIP</A> AS Version", 
+			   GeoIP_database_info(myGlobals.geo_ip_asn_db));
+
 #ifndef WIN32
   if(getDynamicLoadPaths(mainbuf, sizeof(mainbuf), lib, sizeof(lib), env, sizeof(env)) == 0) {
     printFeatureConfigInfo(textPrintFlag, "Running from", mainbuf);
@@ -6570,9 +6568,6 @@
 
   printFeatureConfigInfo(textPrintFlag, "Domain name (short)", myGlobals.shortDomainName);
 
-  safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "%d", myGlobals.ipCountryCount);
-  printFeatureConfigInfo(textPrintFlag, "IP to country flag table (entries)", buf);
-
   safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "%d", myGlobals.hashCollisionsLookup);
   printFeatureConfigInfo(textPrintFlag, "Total Hash Collisions (Vendor/Special) (lookup)", buf);
 
@@ -6799,17 +6794,6 @@
 
     safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "%d", myGlobals.ipxsapHashLoadSize);
     printFeatureConfigInfo(textPrintFlag, "IPX/SAP Hash Size (bytes)", buf);
-
-    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "%d (%.1f MB)", myGlobals.ipCountryMem, (float)myGlobals.ipCountryMem/(1024.0*1024.0));
-    printFeatureConfigInfo(textPrintFlag, "IP to country flag table (bytes)", buf);
-
-    if(myGlobals.ipCountryCount > 0) {
-      safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "%.1f", (float)myGlobals.ipCountryMem/myGlobals.ipCountryCount);
-      printFeatureConfigInfo(textPrintFlag, "Bytes per entry", buf);
-    }
-
-    safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "%d (%.1f MB)", myGlobals.asMem, (float)myGlobals.asMem/(1024.0*1024.0));
-    printFeatureConfigInfo(textPrintFlag, "IP to AS (Autonomous System) number table (bytes)", buf);
   }
 
   printInfoSectionTitle(textPrintFlag, "Host Memory Cache");
@@ -8949,10 +8933,11 @@
       if(fetchPrefsValue(key.dptr, val, sizeof(val)) == 0) {
 	safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf),
 		      "<FORM ACTION="CONST_EDIT_PREFS">"
-		      "<TR><TH ALIGN=LEFT "DARK_BG"><INPUT TYPE=HIDDEN NAME=key VALUE=\"%s\">%s</TH>"
-		      "<TD><INPUT TYPE=TEXT NAME=val VALUE=\"%s\" size=30></TD>"
-		      "<TD ALIGN=CENTER><INPUT TYPE=SUBMIT VALUE=Set></TD></TR></FORM>\n",
-		      key.dptr, key.dptr, val);
+		      "<TR><TH ALIGN=LEFT "DARK_BG"><INPUT TYPE=HIDDEN NAME=key VALUE=\"%s\">"
+			  "<A NAME=\"%s\">%s</A></TH>"
+		      "<TD><INPUT TYPE=TEXT NAME=val VALUE=\"%s\" size=60></TD>"
+		      "<TD ALIGN=CENTER><INPUT TYPE=SUBMIT VALUE=Set></TD></TR></FORM></A>\n",
+		      key.dptr, key.dptr, key.dptr, val);
 	sendString(buf);
       }
     }
